/**
 * Class representing a Tic Tac Toe board/grid
 */
public class TTTModel {
    private Symbol[][] grid;

    //Constructor creates an empty 3x3 grid
    public TTTModel() {
        grid = new Symbol[3][3];

        // loop through the grid to set everything as empty

    }

    /**
     * Marks a tile with X or O symbol so long as the tile is empty
     *
     * @param s    The symbol to be used
     * @param posX X Position of the tile in the grid
     * @param posY Y Position of the tile in the grid
     * @return True if tile can be marked, false if tile already marked
     */
    public boolean markTile(Symbol s, int posX, int posY) {

    }

    //To String method for the model
    @Override
    public String toString() {
        StringBuilder s = new StringBuilder();
        for (Symbol[] symbols : grid) {
            for (Symbol symbol : symbols) {
                // make an if or switch statement to append the right symbol
                }
                s.append("|");
            }
            s.append("\n______\n");
        }
        return s.toString();
    }

    /**
     * Checks the state of the board
     *
     * @return BoardState enum representing state of the board
     */
    public BoardState checkState() {
        boolean legal = true;
        Symbol winner = null;
        //check horizontal
        for (int i = 0; i < 3; i++) {
            if (grid[i][0].equals(grid[i][1]) && grid[i][0].equals(grid[i][2])) {
                legal = false;
                winner = grid[i][0];
                break;
            }
        }
        //check vertical
        for (int i = 0; i < 3; i++) {

        }
        //check diagonal incline
        if (grid[0][2].equals(grid[1][1]) && grid[0][2].equals(grid[2][0])) {
            legal = false;
            winner = grid[0][2];
        }
        //check diagonal decline
        if (grid[0][0].equals(grid[1][1]) && grid[0][0].equals(grid[2][2])) {

        }
        if (legal) return BoardState.Ongoing;
        else {
            if (winner.equals(Symbol.X)) return BoardState.XWin;
            else return BoardState.OWin;
        }
    }

    /**
     * Returns an object containing true and false values for whether either player can win
     *
     * @param nextPlayer The player after the current turn
     * @return object containing true and false values for whether either player can win
     */
    public WinDrawPotentials depthSearchPotentials(Symbol nextPlayer) {
        WinDrawPotentials p = new WinDrawPotentials();
        if (!checkState().equals(BoardState.Ongoing)) {
            if (checkState().equals(BoardState.XWin)) p.setXCanWin(true);
            else p.setOCanWin(true);
            return p;
        } else if (isFull()) return p;
        if (p.getOCanWin() && p.xCanWin) return p;
        else {
            Coordinate c = getNextBlank();
            if (nextPlayer.equals(Symbol.X)) {
                markTile(Symbol.X, c.getX(), c.getY());
                p = depthSearchPotentials(Symbol.O);
            } else {
                markTile(Symbol.O, c.getX(), c.getY());
                p = depthSearchPotentials(Symbol.X);
            }
            unMark(c.getX(), c.getY());
        }
        return p;
    }

    //Unmarks a tile
    private void unMark(int posX, int posY) {
        grid[posX][posY] = Symbol.Empty;
    }

    //Gets the coordinate of the next blank tile
    private Coordinate getNextBlank() {
        for (int i = 0; i < grid.length; i++) {
            for (int j = 0; j < grid.length; j++) {
                // return the coordinates if the symbol is empty
            }
        }
        return new Coordinate(-1, -1);
    }

    /**
     * Class containing two booleans, one for the possibility of either player winning
     */
    public class WinDrawPotentials {
        private boolean xCanWin;
        private boolean oCanWin;

        public WinDrawPotentials() {
            xCanWin = false;
            oCanWin = false;
        }

        public boolean getXCanWin() {
            return xCanWin;
        }

        public void setXCanWin(boolean xCanWin) {
            this.xCanWin = xCanWin;
        }

        public boolean getOCanWin() {
            return oCanWin;
        }

        public void setOCanWin(boolean oCanWin) {
            this.oCanWin = oCanWin;
        }
    }

    //Returns true if there are no empty tiles in the grid
    private boolean isFull() {
        
        return isFull;
    }

    public Symbol[][] getGrid() {
        return grid;
    }

    //extra getter method to facilitate testing
    public Symbol getTile(int posX, int posY){
        return grid[posX][posY];
    }
}